use bevy::prelude::*;

fn main() {
  App::new()
    .add_plugins(DefaultPlugins)
    .add_systems(Startup, setup)
    .add_systems(Update, movement)
    .run();
}
#[derive(Component)]
struct Dragon;

fn setup(//(1)
  mut commands: Commands, //(2)
  asset_server: Res<AssetServer>//(3)
) {
  commands.spawn(Camera2dBundle::default());//(4)
  commands
    .spawn(SpriteBundle {//(5)
      texture: asset_server.load("dragon.png"),//(6)
      ..Default::default()//(7)
    })
    .insert(Dragon);//(8)
}
fn movement(
  keyboard: Res<Input<KeyCode>>,//(9)
  mut dragon_query: Query<&mut Transform, With<Dragon>>,//(10)
) {
  let delta = if keyboard.pressed(KeyCode::Left) {//(11)
    Vec2::new(-1.0, 0.0)
  } else if keyboard.pressed(KeyCode::Right) {
    Vec2::new(1.0, 0.0)
  } else if keyboard.pressed(KeyCode::Down) {
    Vec2::new(0.0, -1.0)
  } else if keyboard.pressed(KeyCode::Up) {
    Vec2::new(0.0, 1.0)
  } else {
    Vec2::ZERO
  };

  dragon_query.for_each_mut(|mut transform| {//(12)
    transform.translation += delta.extend(0.0);//(13)
  });
}
