
use bevy::prelude::*;//(1)

pub struct GameStatePlugin<T> {//(2)
  menu_state: T,//(3)
  game_start_state: T,
  game_end_state: T,
}

impl <T> GameStatePlugin<T>//(4)
{
  #[allow(clippy::new_without_default)]
  pub fn new(menu_state: T, game_start_state: T, game_end_state: T) -> Self 
  {
    Self { menu_state, game_start_state, game_end_state } //(5)
  }
}

impl<T: States> Plugin for GameStatePlugin<T>
{
  fn build(&self, app: &mut App) {
    app.add_state::<T>();
  }
}

pub fn cleanup<T>(//(6)
  query: Query<Entity, With<T>>,//(7)
  mut commands: Commands,
) 
where T: Component//(8)
{
  query.for_each(|entity| commands.entity(entity).despawn())
}
